unit Demo2000;
{$H-}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TkSToMP, Menus;

type
  TForm1 = class(TForm)
    GraphPanel: TPanel;
    DrawModeGrp: TRadioGroup;
    ColorGrp: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    XValTxt: TLabel;
    YValTxt: TLabel;
    MainMenu1: TMainMenu;
    MunFile: TMenuItem;
    MunExit: TMenuItem;
    N1: TMenuItem;
    Mnu2DPrim: TMenuItem;
    MnuLines: TMenuItem;
    MnuBitmap: TMenuItem;
    MunFontfaces: TMenuItem;
    MnuWelcome: TMenuItem;
    MnuFontSizes: TMenuItem;
    mnuTextjustification: TMenuItem;
    mnuWindowscrolling: TMenuItem;
    Mnu2DBasic: TMenuItem;
    MunOpenAxes: TMenuItem;
    MnuCornerAxes: TMenuItem;
    MnuBoxedAxes: TMenuItem;
    N31: TMenuItem;
    MnuBoxedAxes3D: TMenuItem;
    N2: TMenuItem;
    MnuNoMargins: TMenuItem;
    MnuNoSecondaryPips: TMenuItem;
    MnuNoNiceValues: TMenuItem;
    N3: TMenuItem;
    MnuSymbolsandErrorBars: TMenuItem;
    MnuTitles: TMenuItem;
    MnuFractalCurve: TMenuItem;
    N4: TMenuItem;
    MnuRandomViewAngle: TMenuItem;
    MnuRandomViewAngle2: TMenuItem;
    MnuAnimateCube: TMenuItem;
    Plot1: TMenuItem;
    Evaluate1: TMenuItem;
    Help1: TMenuItem;
    Mnu2DCurve: TMenuItem;
    MnuNormalDistribution: TMenuItem;
    Mnu3DCurve: TMenuItem;
    N5: TMenuItem;
    MnuRevolution: TMenuItem;
    MnuContours: TMenuItem;
    MnuWireFrame: TMenuItem;
    MnuSurface: TMenuItem;
    N6: TMenuItem;
    MnuHistogram2D: TMenuItem;
    MnuMoreFractals: TMenuItem;
    MnuUserdefinedFunction: TMenuItem;
    MnuAbout: TMenuItem;
    N7: TMenuItem;
    ClearWindow1: TMenuItem;
    MnuLoglogplot: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure MnuWelcomeClick(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure DrawModeGrpClick(Sender: TObject);
    procedure ColorGrpClick(Sender: TObject);
    procedure GraphMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GraphPanelClick(Sender: TObject);
    procedure MnuLinesClick(Sender: TObject);
    procedure MnuBitmapClick(Sender: TObject);
    procedure MunFontfacesClick(Sender: TObject);
    procedure MnuFontSizesClick(Sender: TObject);
    procedure mnuTextjustificationClick(Sender: TObject);
    procedure mnuWindowscrollingClick(Sender: TObject);
    procedure MunOpenAxesClick(Sender: TObject);
    procedure MnuCornerAxesClick(Sender: TObject);
    procedure MnuBoxedAxesClick(Sender: TObject);
    procedure MnuNoMarginsClick(Sender: TObject);
    procedure MnuNoSecondaryPipsClick(Sender: TObject);
    procedure MnuNoNiceValuesClick(Sender: TObject);
    procedure MnuSymbolsandErrorBarsClick(Sender: TObject);
    procedure MnuTitlesClick(Sender: TObject);
    procedure MnuFractalCurveClick(Sender: TObject);
    procedure MnuBoxedAxes3DClick(Sender: TObject);
    procedure MnuRandomViewAngleClick(Sender: TObject);
    procedure MnuRandomViewAngle2Click(Sender: TObject);
    procedure MnuAnimateCubeClick(Sender: TObject);
    procedure Mnu2DCurveClick(Sender: TObject);
    procedure MnuNormalDistributionClick(Sender: TObject);
    procedure Mnu3DCurveClick(Sender: TObject);
    procedure MnuRevolutionClick(Sender: TObject);
    procedure MnuContoursClick(Sender: TObject);
    procedure MnuWireFrameClick(Sender: TObject);
    procedure MnuSurfaceClick(Sender: TObject);
    procedure MnuHistogram2DClick(Sender: TObject);
    procedure MnuMoreFractalsClick(Sender: TObject);
    procedure MnuUserdefinedFunctionClick(Sender: TObject);
    procedure MnuAboutClick(Sender: TObject);
    procedure MnuLoglogplotClick(Sender: TObject);
    procedure ClearWindow1Click(Sender: TObject);
  private
    { Private declarations }
    id: PkGraph; { the graph window }
    firstShow: boolean; { show welcome message? }
    LastCommand: integer;
    drawOption: integer;   { drawing mode }
    styleOption: integer;  { color style, etc }
    mouseValueMode: integer; { 0 = pixel, 1 = scaled }
    IsWaiting: boolean; { mouse cursor }

    { used by demo routines }
    ct: TkReal; { position of cube on a torus knot }
    th, ph: TkReal; { view angle }
    x, y, z, tx, ty, tz, nx, ny, nz, bx, by, bz: TkReal; { box pos & axes }
    sqx, sqy, sqz: Parray; { for calculation in animation }
    editText: ARRAY [0..500] OF Char; { for inputing expression }

    procedure ResetDefaults(clear: boolean);
    procedure WelcomeMessage;
    procedure SetWaiting(switch: boolean);
    procedure DrawCube;
    procedure SetBoxPos(t: TkReal);
    procedure DrawUserdefinedFunction;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var rect: TRect;
begin
  rect := GraphPanel.ClientRect;
  { now open graph }
  with rect do  id := TkOpenGraph(GraphPanel.Handle, Left, Top, Right, Bottom,
    Background_mode);
  IF id = Nil THEN BEGIN
    ShowMessage('Problem creating graph window. Program Aborted.');
    Destroy;
    Exit
  END;
  drawOption := AutoRedraw_mode;
  styleOption := SToMPLight_settings;
  TkSetDrawingMode(id, drawOption);
  mouseValueMode := 0;
  ResetDefaults(false);
  TkSetMessageRoute(id, GraphPanel.Handle);
  lastCommand := 0;
  sqx := TkNewArray1(4);
  sqy := TkNewArray1(4);
  sqz := TkNewArray1(4);
  editText := 'sin(x) / (1 + x)';
  firstShow := true;
end;


procedure TForm1.FormResize(Sender: TObject);
var newW, newH: integer;
begin
  newW := ClientWidth - GraphPanel.Left - 4;
  newH := ClientHeight - GraphPanel.Top - 4;
  if ((newW > 10) and (newH > 10)) then begin
    GraphPanel.Width := newW;
    GraphPanel.Height := newH;
    IF (id <> Nil) AND (WindowState <> wsMinimized) THEN
      TkResize(id, 0, 0, GraphPanel.Width, GraphPanel.Height);
  end;
  IF (id = Nil) then exit;
  if firstShow then begin
    MnuWelcomeClick(Sender);
    firstShow := false;
  end else begin
    case lastCommand of
      1: mnuLinesClick(Sender);
      2: mnuBitmapClick(Sender);
      3: MunFontfacesClick(Sender);
      4: MnuFontSizesClick(Sender);
      5: MnuTextjustificationClick(Sender);
      6: MnuWindowscrollingClick(Sender);
      7: MunOpenAxesClick(Sender);
      8: MnuCornerAxesClick(Sender);
      9: MnuBoxedAxesClick(Sender);
      10: MnuNoMarginsClick(Sender);
      11: MnuNoSecondaryPipsClick(Sender);
      12: MnuNoNiceValuesClick(Sender);
      13: MnuSymbolsandErrorBarsClick(Sender);
      14: MnuTitlesClick(Sender);
      15: MnuFractalCurveClick(Sender);
      16: MnuBoxedAxes3DClick(Sender);
      17: MnuRandomViewAngleClick(Sender);
      18: MnuRandomViewAngle2Click(Sender);
      19: MnuAnimateCubeClick(Sender);
      20: Mnu2DCurveClick(Sender);
      21: MnuNormalDistributionClick(Sender);
      22: Mnu3DCurveClick(Sender);
      23: MnuRevolutionClick(Sender);
      24: MnuContoursClick(Sender);
      25: MnuWireFrameClick(Sender);
      26: MnuSurfaceClick(Sender);
      27: MnuHistogram2DClick(Sender);
      28: MnuMoreFractalsClick(Sender);
      29: DrawUserdefinedFunction;
      30: MnuLoglogplotClick(Sender);
      31: MnuWelcomeClick(Sender);
    end;
  end;
end;


procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  canclose := true;
  TkDisposeArray(sqx);
  TkDisposeArray(sqy);
  TkDisposeArray(sqz);
  TkCloseGraph(id);
  id := Nil;
end;


PROCEDURE TForm1.ResetDefaults(clear: boolean);
BEGIN
  TkDefaults(id);
  TkSToMPStyle(id, styleOption);
  if clear then begin
    TkClearWindow(id);
    TkDispatchToWindow(id);
  end;
END; { TForm1.ResetDefaults }

procedure TForm1.MnuWelcomeClick(Sender: TObject);
begin
  WelcomeMessage;
  LastCommand := 31;
  mouseValueMode := 0;
end;

procedure TForm1.MnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.DrawModeGrpClick(Sender: TObject);
begin
  case DrawModeGrp.ItemIndex of
    0: drawOption := Foreground_mode;
    1: drawOption := AutoRedraw_mode;
    2: drawOption := Background_mode;
    3: drawOption := DelayRedraw_mode;
    else drawOption := DelayRedraw_mode;
  end;
  TkSetDrawingMode(id, drawOption);
  ResetDefaults(true);
end;

procedure TForm1.ColorGrpClick(Sender: TObject);
begin
  case ColorGrp.ItemIndex of
    0: styleOption := Registry_settings;
    1: styleOption := SToMPLight_settings;
    2: styleOption := SToMPDark_settings;
    3: styleOption := OldIBM_settings;
    else styleOption := OldIBM_settings;
  end;
  ResetDefaults(true);
  TkClearWindow(id);
  TkDispatchToWindow(id);
end;

procedure TForm1.GraphMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var thePos: TPoint;
    s: string;
    userx, usery: TkReal;
    c: array [0..500] of char;
begin
  SetWaiting(IsWaiting);
  if IsWaiting then exit;

  TkGetMousePos(id, thePos);
  if mouseValueMode = 0 then begin // 2D pixel coordinates
    str(thePos.x:5, s);
    XValTxt.Caption := s;
    str(thePos.y:5, s);
    YValTxt.Caption := s;
  end else if mouseValueMode = 1 then begin // 2D user coordinates
    userx := TkWindowToUserX(id, thePos.x, thePos.y);
    TkFormatReal(userx, 8, c);
    s := StrPas(c);
    XValTxt.Caption := s;
    usery := TkWindowToUserY(id, thePos.x, thePos.y);
    TkFormatReal(usery, 8, c);
    s := StrPas(c);
    YValTxt.Caption := s;
  end else begin
    s := ' --- ';
    XValTxt.Caption := s;
    YValTxt.Caption := s;
  end
end;

procedure TForm1.GraphPanelClick(Sender: TObject);
begin
  XValTxt.caption := 'clicked';
end;

PROCEDURE TForm1.WelcomeMessage;
VAR temp: string;
    c: array [0..500] of char;
BEGIN
  TkClearWindow(id);
  TkGpText(id, 5, 15,                  'Hello world!                          22 May 00 Testing');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), '');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'You can test out various Toolkit functions by selecting');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'appropiate meun items. Automatic redrawing is supported');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'so that the window will redraw itself.  Simulations can be');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'done in DelayRedraw mode to minimize flicking. Resizing');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'is supported in the sense that graph can change size');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'without losing its properties, but the user needs to redraw');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'the picture.');
  TkGpText(id, 5, TkEndTextY(id) + (TkCellHeight(id) * 3) div 2, 'This program was originally written in Turbo Pascal for');
  TkGpText(id, 5, TkEndTextY(id) + TkCellHeight(id), 'Windows, now ported to Win32 using Delphi 2.0');
  temp := 'DLL version number: '+IntToShortStr(TkGetVersion);
  strpcopy(c, temp);
  TkGpText(id, 5, TkEndTextY(id) + (TkCellHeight(id) * 3) div 2, c);
  TkDispatchToWindow(id);
END; { WelcomeMessage }


PROCEDURE TForm1.SetWaiting(switch: boolean);
BEGIN
  IsWaiting := switch;
  IF IsWaiting THEN
    TkSetMouseShape(id, Hourglass_shape)
  ELSE
    TkSetMouseShape(id, Arrow_shape)
END; { TForm1.SetWaiting }


procedure TForm1.MnuLinesClick(Sender: TObject);
CONST del = 4;
VAR dth, th1, th2: real; size: TPoint;
    cx, cy, rad, i, j, imin: integer;

  PROCEDURE AddPixel(x1,y1, x2,y2, x3,y3: integer);
  VAR x12,y12, x23,y23, x13,y13: integer;
  BEGIN
    x12 := (x1+x2) DIV 2; y12 := (y1+y2) DIV 2;
    x23 := (x3+x2) DIV 2; y23 := (y3+y2) DIV 2;
    x13 := (x1+x3) DIV 2; y13 := (y1+y3) DIV 2;
    IF ABS(x12-x23)+ABS(x23-x13)+ABS(x12-x13) <= del THEN Exit;
    IF ABS(y12-y23)+ABS(y23-y13)+ABS(y12-y13) <= del THEN Exit;
    IF ABS(y12-y23)+ABS(y23-y13)+ABS(y12-y13) > 32 * del THEN
      TkDispatchToWindow(id);
    TkGpColorPixel(id, x12, y12, TkYellow);
    TkGpColorPixel(id, x23, y23, TkRed);
    TkGpColorPixel(id, x13, y13, TkLightCyan);
    AddPixel(x12,y12, x23,y23, x13, y13);
    AddPixel(x1,y1, x12,y12, x13, y13);
    AddPixel(x2,y2, x23,y23, x12, y12);
    AddPixel(x3,y3, x13,y13, x23, y23);
  END;
BEGIN
  ResetDefaults(true);
  SetWaiting(true);
  size.X := TkWindowWidth(id);
  size.Y := TkWindowHeight(id);
  cx := size.X DIV 3;
  cy := size.Y DIV 2;
  imin := size.X DIV 3;
  IF size.Y DIV 2 < imin THEN imin := size.Y DIV 2;
  rad := imin - 1;
  TkGpCircle(id, cx, cy, rad, false);
  dth := 2*Pi/32;
  th1 := 0; th2 := Pi*7/9;
  REPEAT
    TkGpLine(id, Round(cx+rad*cos(th1)), Round(cy+rad*sin(th1)),
      Round(cx+rad*cos(th2)), Round(cy+rad*sin(th2)));
    TkGpCircle(id, Round(cx+rad*cos(th1)), Round(cy+rad*sin(th1)), 4, false);
    TkGpCircle(id, Round(cx+rad*cos(th2)), Round(cy+rad*sin(th2)), 4, true);
    th1 := th1 + dth; th2 := th2 + dth;
  UNTIL th1 > 2*Pi+dth/2;
  TkDispatchToWindow(id);
  AddPixel(size.X DIV 2, size.Y, size.X * 4 DIV 5, 0, size.X, size.Y);
  TkDispatchToWindow(id);
  TkGpText(id, TkWindowWidth(id) - 300, 15,  '    This is an example');
  TkGpText(id, TkWindowWidth(id) - 300, 35, 'output using Gp_graphic_text');
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 1;
  mouseValueMode := 0;
END; { TForm1.mnuLinesClick }

procedure TForm1.MnuBitmapClick(Sender: TObject);
TYPE int8 = ARRAY[1..8,1..2] OF integer;
     Pint8 = ^int8;
VAR i: integer;
    quad, quad2 : Pint8;
    hb: TkBitmap;
BEGIN
  SetWaiting(true);
TkSetMouseShape(id, Dot_shape);
  New(quad);
  New(quad2);
  TkGraphColor(id, TkGreen);
  TkWritemode(id, Actual_mode);
  FOR i := 1 TO 8 DO BEGIN
    quad^[i,1] := trunc(TkWindowWidth(id) - 250+40*cos(i*2*Pi/7));
    quad^[i,2] := trunc(90+40*sin(i*2*Pi/7));
    quad2^[i,1] := quad^[i,1] + 160;
    quad2^[i,2] := quad^[i,2];
  END;
  TkGpPoly(id, 8, coordptr(quad), true);
  TkGpPoly(id, 8, coordptr(quad2), false);
  TkGpText(id, TkWindowWidth(id) - 270, 150, 'fill');
  TkGpText(id, TkWindowWidth(id) - 270 + 160, 150, 'unfill');
  FOR i := 1 TO 6 DO BEGIN
    quad^[i,1] := trunc(50+40*cos(i*2*Pi/5));
    quad^[i,2] := trunc(70+40*sin(i*2*Pi/5));
  END;
  TkDispatchToWindow(id);
  TkWritemode(id, EOR_mode);
  TkGpPoly(id, 6, coordptr(quad), true);
  hb := TkGetImage(id, 10, 30, 90, 110);
  TkGpPoly(id, 6, coordptr(quad), true);
  FOR i := 0 TO 200 DO BEGIN
    TkPutImage(id, 10+i, 30+i, hb, EOR_mode);
    TkDispatchToRect(id, 9+i, 29+i, 90+i, 110+i);
    TkPutImage(id, 10+i, 30+i, hb, EOR_mode);
  END;
  FOR i := 200 DOWNTO 0 DO BEGIN
    TkPutImage(id, 10+i, 30+i, hb, EOR_mode);
    TkDispatchToRect(id, 10+i, 30+i, 91+i, 111+i);
    TkPutImage(id, 10+i, 30+i, hb, EOR_mode);
  END;
  TkClearImage(hb);
  TkDispatchToWindow(id);
  TkGraphColor(id, TkCyan);
  SetWaiting(false);
  LastCommand := 2;
  mouseValueMode := 0;
END; { TForm.mnuBitmapClick }

procedure TForm1.MunFontfacesClick(Sender: TObject);
VAR ix, NextY: integer;
BEGIN
  ResetDefaults(true);
  SetWaiting(true);
  TkTextJustified(id, Centre_justified);
  ix := TkWindowWidth(id) DIV 2;
  TkFont(id, Roman_face, Italic_style, 12);
  TkTextColor(id, TkGreen);
  TkGpText(id, ix, 15,'Roman Italic 12 points in Green');
  NextY := TkEndTextY(id) + TkCellHeight(id);
  TkGpText(id, ix, NextY, 'The above text is drawn by the following lines:');
  NextY := TkEndTextY(id) + TkCellHeight(id);
  TkGpText(id, ix, NextY, '  TkFont(id, Roman_face, Italic_style, 12); ');
  NextY := TkEndTextY(id) + TkCellHeight(id);
  TkGpText(id, ix, NextY, '  TkTextColor(id, TkGreen);');
  NextY := TkEndTextY(id) + TkCellHeight(id);
  TkGpText(id, ix, NextY, '  TkGpText(id, 5, 15,''Roman Italic 12 points in Green'');');
  TkTextColor(id, TkRed);
  TkFont(id, Roman_face, BoldnItalic_style, 24);
  NextY := TkEndTextY(id) + TkCellHeight(id);
  TkGpText(id, ix, NextY, 'Roman BoldItalic 24 points in red');
  TkFont(id, Helv_face, Bold_style, 13);
  NextY := TkEndTextY(id) + TkCellHeight(id);
  TkTextColor(id, TkYellow);
  TkGpText(id, ix, NextY, 'Helv (Arial) Bold 13 points in yellow');
  TkFont(id, Symbol_face, Plain_style, 14);
  NextY := TkEndTextY(id) + TkCellHeight(id);
  TkGpText(id, ix, NextY, 'Symbol Plain 14 points in yellow');
  ResetDefaults(false);
  TkTextJustified(id, Centre_justified);
  NextY := NextY + TkCellHeight(id);
  TkTextColor(id, TkLightBlue);
  TkGpText(id, ix, 200,'Back to The default font!');
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 3;
  mouseValueMode := 0;
END; { TForm1.MunFontfacesClick }


procedure TForm1.MnuFontSizesClick(Sender: TObject);
VAR i, ix: integer;
    str: string;
    c: array[0..500] of char;
BEGIN
  ResetDefaults(true);
  TkGpText(id, 5, 15,'Plain Roman with variable size ...');
  TkDispatchToWindow(id);
  SetWaiting(true);
  ix := 5;
  FOR i := 20 DOWNTO 0 DO BEGIN
    TkFont(id, Roman_face, Plain_style, i);
    str := 'Now in Roman ' + inttostr(i) + ' points';
    strpcopy(c, str);
    IF i = 11 THEN BEGIN
      ix := 300;
      TkGpText(id, ix, 40 + TkCellHeight(id), c)
    END ELSE
      TkGpText(id, ix, TkEndTextY(id) + TkCellHeight(id), c);
  END;
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 4;
  mouseValueMode := 0;
END; { TForm1.MnuFontSizesClick }

procedure TForm1.mnuTextjustificationClick(Sender: TObject);
VAR x1, y1, x2, y2: integer;
    sizex, sizey: integer;
    str: string;
    c: array [0..500] of char;
begin
  ResetDefaults(true);
  str := 'Happy SToMPing';
  strpcopy(c, str);
  x1 := 40;
  y1 := 60;
  x2 := TkWindowWidth(id)-40;
  y2 := TkWindowHeight(id)-40;
  TkGpRectangle(id, x1, y1, x2, y2, true);
  SetWaiting(true);
  { explain }
  TkGpText(id, 5, 15, 'This demo illustrates Right-Justified mode in different orientations.');
  TkDispatchToWindow(id);
  { prepare font settings }
  TkTextColor(id, TkRed);
  TkTextJustified(id, Right_Justified);
  { top }
  TkFont2(id, 1, 1, 24, 1);
  TkGpText(id, x2, y1, MakePChar(str));
  { left }
  TkFont2(id, 1, 1, 24, 2);
  TkGpText(id, x1, y1, MakePChar(str));
  { bottom }
  TkFont2(id, 1, 1, 24, 3);
  TkGpText(id, x1, y2, MakePChar(str));
  { right }
  TkFont2(id, 1, 1, 24, 4);
  TkGpText(id, x2, y2, MakePChar(str));
  TkDispatchToWindow(id);
  SetWaiting(false);
  ResetDefaults(false);
  LastCommand := 5;
  mouseValueMode := 0;
end; { TForm1.mnuTextjustificationClick }

procedure TForm1.mnuWindowscrollingClick(Sender: TObject);
VAR x1, y1, x2, y2, i: integer;
BEGIN
  ResetDefaults(false);
  SetWaiting(true);
  x1 := TkWindowWidth(id) DIV 5; x2 := TkWindowWidth(id) - x1;
  y1 := TkWindowHeight(id) DIV 5; y2 := TkWindowHeight(id) - y1;
  TkGpRectangle(id, x1, y1, x2, y2, false);
  TkGpText(id, x1 + 2, y2 - TkCellHeight(id) - 2,'Scroll up and up and up ...');
  TkDispatchToWindow(id);
  FOR i := 1 TO (y2-y1+2) DIV 2 DO BEGIN
    TkScrollRect(id, x1+1, y1+1, x2-1, y2-1, 0, -2);
    TkDispatchToRect(id, x1+1, y1+1, x2-1, y2-1)
  END;
  SetWaiting(false);
  LastCommand := 6;
  mouseValueMode := 0;
end; { TForm1.mnuWindowscrollingClick }

procedure TForm1.MunOpenAxesClick(Sender: TObject);
begin
  ResetDefaults(true);
  TkSetMargins(id, 15, 15, 15, 15);
  TkSetRanges(id, -10000, 100000, -10, 10);
  { TkSetColors(id, TkBlue, TkBlue, TkBlue, TkBlue); }
  TkSetScales(id);
  { TkDrawGrid(id); }
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkDispatchToWindow(id);
  LastCommand := 7;
  mouseValueMode := 1;
end;

procedure TForm1.MnuCornerAxesClick(Sender: TObject);
begin
  ResetDefaults(true);
  TkSetGraphParam(id, AxesType_gp, Corner_axes);
  {TkSetMargins(id, 50, 20, 20, 30);}
  TkSetRanges(id, -107.55, +657.63, -888.76, -38.65);

  TkSetTitleString(id, XAxis_title, 'X-axis shown here');
  TkSetTitleString(id, YAxis_title, 'Y-axis shown here');
  TkSetGraphParam(id, AutoMargins_gp, 1);

  TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkDispatchToWindow(id);
  LastCommand := 8;
  mouseValueMode := 1;
end;

procedure TForm1.MnuBoxedAxesClick(Sender: TObject);
BEGIN
  ResetDefaults(true);
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkSetMargins(id, 50, 20, 20, 30);
  TkSetRanges(id, -15, +3, 7, 65);
  TkSetScales(id);
  TkSetGraphParam(id, xpipm_gp, Inside_pips);
  TkSetGraphParam(id, ypipm_gp, Inside_pips);

  { new: user-defined grid drawing }
  TkSetGraphParam(id, GridOption_gp, 2);
  TkSetGraphColor(id, GridLine1_color, TkGreen);
  TkSetGraphColor(id, GridLine2_color, TkGreen);
  TkSetGraphParam(id, GridStyle1_gp, Solid_line);
  TkSetGraphParam(id, GridStyle2_gp, Dotted_line);

  TkDrawAxes(id);
  TkLabelAxes(id);
  TkDispatchToWindow(id);
  LastCommand := 9;
  mouseValueMode := 1;
END;


procedure TForm1.MnuNoMarginsClick(Sender: TObject);
BEGIN
  ResetDefaults(true);
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkSetMargins(id, 0, 0, 0, 0);
  TkSetRanges(id, -15, +3, 7, 65);
  TkSetScales(id);
  TkSetGraphParam(id, xpipm_gp, Inside_pips);
  TkSetGraphParam(id, ypipm_gp, Inside_pips);
  TkDrawAxes(id);
  TkGpText(id, 55, 55, 'TkSetMargins(id, 0, 0, 0, 0)');
  LastCommand := 10;
  mouseValueMode := 1;
END;

procedure TForm1.MnuNoSecondaryPipsClick(Sender: TObject);
BEGIN
  ResetDefaults(true);
  TkSetGraphParam(id, AxesType_gp, Corner_axes);
  TkSetMargins(id, 50, 40, 20, 30);
  TkSetRanges(id, -107.55, +657.63, -888.76, -38.65);
  TkSetScales(id);
  TkSetGraphParam(id, nSubxi_gp, 0);
  TkSetGraphParam(id, nSubyi_gp, 0);
  TkGpText(id, 105, 15, 'TkSetGraphParam(id, nSubyi_gp, 0)');
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkDispatchToWindow(id);
  LastCommand := 11;
  mouseValueMode := 1;
END;


procedure TForm1.MnuNoNiceValuesClick(Sender: TObject);
VAR temp: LabelSettings;
BEGIN
  ResetDefaults(true);
  TkSetGraphParam(id, AxesType_gp, open_axes);
  TkSetMargins(id, 20, 0, 20, 30);
  TkSetRanges(id, -1067.55, +657.63, -99.76, -27);
  TkSetGraphParam(id, AutoNiceValues_gp, 0);
  TkGetLabelSettings(id, Yaxis_label, temp);
  temp.AxisEndMode := Invisible_ends;
  TkSetLabelSettings(id, Yaxis_label, @temp);
  TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkGpText(id, 5, 15, 'TkSetRanges(id, -1067.55, +657.63, -99.76, -27)');
  TkDispatchToWindow(id);
  LastCommand := 12;
  mouseValueMode := 1;
END;


procedure TForm1.MnuSymbolsandErrorBarsClick(Sender: TObject);
VAR i: integer;
    temp: LabelSettings;
BEGIN
  ResetDefaults(true);
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkSetMargins(id, 52, 14, 20, 28);
  TkSetRanges(id, -107.55, +657.63, -888.76, -38.65);
  TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  FOR i := 1 TO 8 DO TkPlotSymbol(id, -180 + 100*i, -850 + 100*i, i);
  TkErrorBar(id, 100, -200, 0, 100, FilledSquare_symbol);
  i := 5;
  TkGraphLabel(id, -150 + 100*i, -850 + 100*i, '5 = Triangle');
  TkGetLabelSettings(id, data_label, temp);
  temp.AutoPosition := true;
  TkSetLabelSettings(id, data_label, @temp);
  i := 7;
  TkGraphLabel(id, -150 + 100*i, -850 + 100*i, '7 = Filled square');
  TkDispatchToWindow(id);
  LastCommand := 13;
  mouseValueMode := 1;
END;


procedure TForm1.MnuTitlesClick(Sender: TObject);
BEGIN
  ResetDefaults(true);
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkSetGraphParam(id, xpipm_gp, Inside_pips);
  TkSetGraphParam(id, ypipm_gp, Inside_pips);
  TkSetMargins(id, 80, 40, 20, 60);
  { 2D example }
  TkSetRanges(id, -108, +309, -833, +556);
  TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkGraphTitle(id, Graph_title, 'SToMP Graphics DLL');
  TkGraphTitle(id, XAxis_title, 'The x-axis');
  TkGraphTitle(id, YAxis_title, 'The y-axis');
  { 3D example }
  {TkSetView3D(id);
  TkSetRanges3(id, -1088, +3099, -334, +5565, -4444, -1111);
  TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkGraphTitle(id, Graph_title, 'SToMP Graphics DLL');
  TkGraphTitle(id, XAxis_title, 'The x-axis');
  TkGraphTitle(id, YAxis_title, 'The y-axis');
  TkGraphTitle(id, ZAxis_title, 'The z-axis');}
  TkDispatchToWindow(id);
  LastCommand := 14;
  mouseValueMode := 1;
END;


procedure TForm1.MnuFractalCurveClick(Sender: TObject);
 { Level 1 example: basic drawing, fractal curves, from RDH}
CONST SIDE = 2.0;  {length of side of original triangle}
VAR		minlength: TkReal;
      hand, sx, sy: TkReal;
  {-- local ----------------------------------------------------------------}
	PROCEDURE doside (angle, length: TkReal);
     {  hand = +1 for right handed, -1 for left}
	BEGIN
    {do not test for Escape - change this later }
		IF length < minlength THEN BEGIN
			TkMoveabs(id, sx, sy);
			sx := sx + length * Cos(angle);
			sy := sy + length * Sin(angle);
			TkDrawabs(id, sx, sy);
			Exit;
		END;
    {if length large enough proceed recursively }
		length := length / 3.0;
		doside(angle, length);
		angle := angle - hand * Pi / 3.0;
		doside(angle, length);
		angle := angle + hand * 2 * Pi / 3.0;
		doside(angle, length);
		angle := angle - hand * Pi / 3.0;
		doside(angle, length)
	END; {of DoSide}
  {-- local ----------------------------------------------------------------}
	PROCEDURE triangle (xcentre, ycentre, side, theta: TkReal);
	VAR r, alpha: TkReal;
	BEGIN
		r := side / Sqrt(3);
		alpha := theta - Pi / 6.0;
		sx := xcentre + r * Cos(alpha);
		sy := ycentre + r * Sin(alpha);
		theta := theta + 2 * Pi / 3.0;
		doside(theta, side);
		theta := theta + 2.0 * Pi / 3.0;
		doside(theta, side);
		theta := theta + 2.0 * Pi / 3.0;
		doside(theta, side)
	END;  {of triangle}
{-- Main -------------------------------------------------------------------}
BEGIN
  ResetDefaults(true);
  SetWaiting(true);
  {set up axes}
  TkSetRanges(id, -1.5, 1.5, -1.5, 1.5);
  minlength := 9 * (1.5 - (-1.5)) / TkWindowWidth(id);
	TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  hand := -1.0;
	TkGraphColor(id, TkCyan);
	triangle(0, 0, SIDE, 0);
  hand := +1.0;
	TkGraphColor(id, TkLightRed);
	triangle(0, 0, SIDE, Pi / 3);
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 15;
  mouseValueMode := 1;
END; { Fractal curve }


procedure TForm1.MnuBoxedAxes3DClick(Sender: TObject);
BEGIN
  ResetDefaults(true);
  TkSetView3D(id);
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  {TkSetGraphParam(id, yfield_gp, -1);
  TkSetGraphParam(id, zfield_gp, -1);}
  TkSetRanges3(id, -18, +28, 0, 30, 20, 40);
  TkSetScales(id);
  {TkSetGraphParam(id, xpipm_gp, Inside_pips);
  TkSetGraphParam(id, ypipm_gp, Inside_pips);}
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkDispatchToWindow(id);
  LastCommand := 16;
  mouseValueMode := 2;
END;


PROCEDURE TForm1.DrawCube;
{ Does not dispatch; no need to set graph window because this procedure
  is only called internally. }
VAR cx, cy, cz: TkReal;
BEGIN
  cx := x + (tx + nx + bx) / 2;   // start at top-right-far corner
  cy := y + (ty + ny + by) / 2;
  cz := z + (tz + nz + bz) / 2;
  TkMoveabs3(id, cx, cy, cz);
  cx := cx - tx;  cy := cy - ty;  cz := cz - tz;
  TkSetArray1(sqx, 1, cx);
  TkSetArray1(sqy, 1, cy);
  TkSetArray1(sqz, 1, cz);
  // sq[1, 1] := cx;  sq[1, 2] := cy;  sq[1, 3] := cz;
  TkDrawrel3(id, -tx, -ty, -tz); // 4 steps for top square
  cx := cx - nx;  cy := cy - ny;  cz := cz - nz;
  TkSetArray1(sqx, 2, cx);
  TkSetArray1(sqy, 2, cy);
  TkSetArray1(sqz, 2, cz);
  TkDrawrel3(id, -nx, -ny, -nz);
  cx := cx + tx;  cy := cy + ty;  cz := cz + tz;
  TkSetArray1(sqx, 3, cx);
  TkSetArray1(sqy, 3, cy);
  TkSetArray1(sqz, 3, cz);
  TkDrawrel3(id, +tx, +ty, +tz);
  cx := cx + nx;  cy := cy + ny;  cz := cz + nz;
  TkSetArray1(sqx, 4, cx);
  TkSetArray1(sqy, 4, cy);
  TkSetArray1(sqz, 4, cz);
  TkDrawrel3(id, +nx, +ny, +nz);
  TkDrawrel3(id, -bx, -by, -bz); // draw line and move down
  TkDrawrel3(id, -tx, -ty, -tz); // 4 steps for bottom square
    TkDrawrel3(id, +bx, +by, +bz);  // draw vertical line as we pass by
    TkMoverel3(id, -bx, -by, -bz);
  TkDrawrel3(id, -nx, -ny, -nz);
    TkDrawrel3(id, +bx, +by, +bz);
    TkMoverel3(id, -bx, -by, -bz);
  TkDrawrel3(id, +tx, +ty, +tz);
    TkDrawrel3(id, +bx, +by, +bz);
    TkMoverel3(id, -bx, -by, -bz);
  TkDrawrel3(id, +nx, +ny, +nz);
  TkFillPolygon3 (id, sqx, sqy, sqz, 4);
END; { DrawCube }


CONST FixOrigin: boolean = false;
{ used by Random View Angle and Random View Angle 2 }

procedure TForm1.MnuRandomViewAngleClick(Sender: TObject);
CONST count = 100; { animation steps }
VAR i: integer;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkSetRanges3(id, -5, 5, -8, 5, -5, 15);
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkSetGraphParam(id, Auto3DOrigin_gp, byte(NOT FixOrigin));
  TkSetView3D(id);
  TkSetViewangles(id, th, ph);
  Randomize;
  FOR i := 1 TO count DO BEGIN
    th := th + 0.03;
    ph := ph + 0.03;
    TkSetViewangles(id, th, ph);
    TkSetScales(id);
    TkClearWindow(id);
    TkGraphColor(id, TkLightGray);
    IF FixOrigin THEN
      TkDrawBox(id)
    ELSE BEGIN
      TkDrawAxes(id);
      TkLabelAxes(id);
    END;
    TkGraphColor(id, TkCyan);
    DrawCube;
    TkDispatchToWindow(id);
  END;
  SetWaiting(false);
  LastCommand := 17;
  mouseValueMode := 2;
END; { Random View }


procedure TForm1.MnuRandomViewAngle2Click(Sender: TObject);
BEGIN
  FixOrigin := true;
  MnuRandomViewAngleClick(Sender);
  FixOrigin := false;
  LastCommand := 18;
END; { Random View 2 }


CONST Blength: TkReal = 3.0;
      dt: TkReal = 1e-4;
{ used by SetBoxPos below }

PROCEDURE TForm1.SetBoxPos(t: TkReal); { used by AnimateCube }
  { calculate new box position and box axis directions }

  PROCEDURE PosOnKnot(VAR x, y, z: TkReal; tnow: TkReal);
  { calculate position of point t on knotted curve }
  CONST R = 3; eR = 1; m = 2; n = 3;
  BEGIN
    x := (R + eR * cos(n * tnow)) * cos(m * tnow);
    y := (R + eR * sin(n * tnow)) * cos(m * tnow);
    z := R * sin(m * tnow);
  END; { PosOnKnot }

VAR norm: TkReal;
BEGIN
  { get t by dX/dt }
  PosOnKnot(x, y, z, t);
  PosOnKnot(tx, ty, tz, t + dt);
  tx := tx - x;   ty := ty - y;    tz := tz - z;
  norm := Sqrt(tx*tx + ty*ty + tz*tz) / Blength;
  tx := tx / norm;    ty := ty / norm;    tz := tz / norm;
  { get n by t ^ (0, 0, 1) }
  nx := ty;      ny := - tx;    nz := 0;
  norm := Sqrt(nx*nx + ny*ny) / Blength;
  nx := nx / norm; ny := ny / norm;
  { get b by t ^ n }
  bx := - tz * ny; by := nx * tz; bz := tx * ny - ty * nx;
  norm := Sqrt(bx*bx + by*by + bz*bz) / Blength;
  bx := bx / norm; by := by / norm; bz := bz / norm;
END; { Setboxpos }


procedure TForm1.MnuAnimateCubeClick(Sender: TObject);
CONST count = 600;
VAR xsc, ysc, i, MaxPx, MaxPy: integer;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkSetRanges3(id, -5, 5, -8, 5, -5, 15);
  TkSetView2D(id);
  TkSetScales(id);
  MaxPx := Abs(TkUserToWindowX(id, BLength, 0) - TkUserToWindowX(id, 0, 0));
  MaxPy := Abs(TkUserToWindowY(id, 0, BLength) - TkUserToWindowY(id, 0, 0));
  TkSetView3D(id);
  TkSetViewangles(id, th, ph);
  TkSetScales(id);
  TkGraphColor(id, TkLightGray);
  TkDrawBox(id);
  TkDispatchToWindow(id);
  TkWritemode(id, EOR_mode);
  TkGraphColor(id, TkCyan);
  FOR i := 1 TO count DO BEGIN
    DrawCube;
    xsc := TkUserToWindowX3(id, x, y, z);
    ysc := TkUserToWindowY3(id, x, y, z);
    TkDispatchToRect(id, xsc - MaxPx, ysc - MaxPy, xsc + MaxPx, ysc + MaxPy);
    DrawCube;
    ct := ct + 0.01; { cube velocity }
    IF ct > 2*Pi THEN ct := ct - 2*Pi;
    SetBoxPos(ct);
  END;
  TkWritemode(id, Actual_mode);
  DrawCube;
  SetWaiting(false);
  LastCommand := 19;
  mouseValueMode := 2;
END; { AnimateCube }


procedure TForm1.Mnu2DCurveClick(Sender: TObject);
VAR result: TkReal;
    buffer: ARRAY [0..500] OF Char;
    bufstr: string;
BEGIN
  ResetDefaults(true);
  TkSetMargins(id, 5 * TkCellWidth(id), 15 + 3 * TkCellHeight(id), 5 *
    TkCellWidth(id), 2 * TkCellWidth(id));
  TkSetRanges(id, 0, 5.5, -50, 50);
  TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkGpText(id, 5, 15, 'Computing ....');
  TkClearParaList(id);
  TkAddParaList(id, 'a', 3.0);
  TkAddParaList(id, 'b', 2.0);
  TkDrawCurve1(id, '50 * exp(-x) / (x-a) / (x-b)', 'x', 0, 5, 128,
    TkLightGreen, Preset);
  TkGpFill(id, 0, 0, TkWindowWidth(id), TkCellHeight(id) * 3 DIV 2, TkGetGraphColor(id,
    GraphBkgnd_color), Actual_mode);
  TkGpText(id, 5, 15, 'f(x) = 50 * exp(- x) / (x-a) / (x-b), a = 3, b = 2');

  { this tests Evaluation with para list ... }
  TkEvaluateEx0ByVar(id, 'a + b', result);
  bufstr := 'Testing parameter evaluation: a + b = ' + RealToStr(result,2);
  StrPCopy(buffer, bufstr);
  TkGpText(id, 5, 15 + TkCellHeight(id), buffer);

  TkDispatchToWindow(id);
  LastCommand := 20;
  mouseValueMode := 1;
END; { 2D Curve (Draw) }


procedure TForm1.MnuNormalDistributionClick(Sender: TObject);
VAR i: integer;
    mode: Axismodeoption;
    clr: ARRAY [3..6] OF TkColor;
    sigma: TkReal;
    sigmastr, MNd: string;
    cMNd: ARRAY [0..255] OF Char;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  sigma := 1;
  TkSetMargins(id, TkCellWidth(id), 3 * TkCellHeight(id), TkCellWidth(id),
    2*TkCellHeight(id));
  TkGpText(id, 5, 15, 'Normal distribution with zero mean');
  TkDispatchToWindow(id);
  clr[3] := TkLightCyan;
  clr[4] := TkLightred;
  clr[5] := TkLightblue;
  clr[6] := TkLightgreen;
  mode := AutoAxes;
  FOR i := 3 TO 6 DO BEGIN
    sigma := i / 3.0;
    str(sigma:2, sigmastr);
    MNd := 'exp( -x * x / 2/ ' + sigmastr + ') / sqrt(2 * Pi)/'
      + sigmastr;
    StrPCopy(cMNd, MNd);
    TkDrawCurve1(id, cMNd, 'x', -4, 4, 128, clr[i], mode);
    TkTextColor(id, clr[i]);
    TkGpText(id, 2, 2 + (i-1)*TkCellHeight(id), '---');
    TkGpText(id, 6, TkEndTextY(id), '---');
    MNd := ' sigma = ' + sigmastr;
    StrPCopy(cMNd, MNd);
    TkGpText(id, TkEndTextX(id), TkEndTextY(id), cMNd);
    TkDispatchToWindow(id);
    mode := Preset
  END;
  SetWaiting(false);
  LastCommand := 21;
  mouseValueMode := 1;
END; { Normal distribution }


procedure TForm1.Mnu3DCurveClick(Sender: TObject);
VAR Mf3d: TFarProc;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkSetMargins(id, TkCellWidth(id), 0, TkCellWidth(id), 0);
  TkGpText(id, 5, 15, 'Continuous curve on a saddle');
  TkGpText(id, 5, 15 + 1 * TkCellHeight(id), '  x = t * cos(48 * Pi * t)');
  TkGpText(id, 5, 15 + 2 * TkCellHeight(id), '  y = t * sin(48 * Pi * t)');
  TkGpText(id, 5, 15 + 3 * TkCellHeight(id), '  z = t^(3/2) * cos(96 * Pi * t)');
  TkDispatchToWindow(id);
  TkDrawCurve3(id, 't * cos(48 * Pi * t)', 't * sin(48 * Pi * t)',
    't^(3/2) * cos(96 * Pi * t)', 't', 0, 1, 256, TkCyan, Autoaxes);
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 22;
  mouseValueMode := 2;
END; { 3D Curve }


procedure TForm1.MnuRevolutionClick(Sender: TObject);
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkSetMargins(id, TkCellWidth(id), 2 * TkCellHeight(id), TkCellWidth(id),
    TkCellWidth(id));
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkGpText(id, 5, 15, 'Revolution of f(x) = 2 + sin(x)');
  TkDispatchToWindow(id);
  TkDrawRevolution(id, '2 + sin(x)', 'x', -Pi, Pi, 16, 32, Surface,
    TkCyan, TkBlue, AutoAxes);
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 23;
  mouseValueMode := 2;
END; { Revolution }


procedure TForm1.MnuContoursClick(Sender: TObject);
CONST rlx = -2; rhx = 2;
      rly = -1; rhy = 3;
      ndata = 48;
      ncontrs = 20;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkSetMargins(id, 3 * TkCellWidth(id), 3*TkCellHeight(id),
    3 * TkCellWidth(id), 3 * TkCellHeight(id));
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkSetGraphParam(id, xpipm_gp, Inside_pips);
  TkSetGraphParam(id, ypipm_gp, Inside_pips);
  TkGpText(id, 5, 15, 'Contour of Rosenbrock''s function');
  TkGpText(id, 5, 15+TkCellHeight(id), '  f(x) = 10 * (y - x^2)^2 + (1 - x)^2');
  TkDispatchToWindow(id);
  TkDrawContours(id, '10 * (y - x^2)^2 + (1 - x)^2', 'x', 'y',
    rlx, rhx, rly, rhy, ndata, ndata + 10, ncontrs, 0, 20, CONTOURS2D,
    TkCyan, Autoaxes);
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 24;
  mouseValueMode := 1;
END; { Contours }


procedure TForm1.MnuWireFrameClick(Sender: TObject);
{ Solution of Laplace's equation - adopted from MHB 27/8/89 }
{ Solve Laplace equation on a circular disk with differential heating
  from -Degree (left) to +Degree (right). }
CONST knx = 40; kny = 25;
      ncontours = 9;
      Count = 100;  Sc = 4;
      Degree = 3;
      xl = -Pi; xh = Pi;  { later it is assumed that xl = -xh, yl = -yh }
      yl = -Pi; yh = Pi;
      Radius = Pi;
TYPE GaussArray = ARRAY [1..knx+1, 1..kny+1] OF TkReal;
     PGaussArray = ^GaussArray;
VAR u, xref, yref: PArray;
    b: ARRAY [1..knx+1, 1..kny+1] OF boolean;
    i, j: integer;
    dx, dy: TkReal;

  {-- Local procedure ------------------------------------------------------}
  PROCEDURE setranges;
  VAR i, j: integer;
  BEGIN
    TkSetRanges3(id, xl, xh, yl, yh, -Degree, Degree);
    TkSetOrigin(id, xl, yl);
    TkSetMargins(id, TkCellWidth(id), 3 * TkCellHeight(id), TkCellWidth(id), TkCellWidth(id));
    dx := (xh - xl) / knx;
    dy := (yh - yl) / kny;
    TkSetScales(id);
    { calibrate reference arrays }
    FOR i := 1 TO knx+1 DO TkSetArray1(xref, i, xl + (i-1) * dx);
    FOR j := 1 TO kny+1 DO TkSetArray1(yref, j, yl + (j-1) * dy);
  END;

  {-- Local procedure ------------------------------------------------------}
  PROCEDURE drawregion(init: boolean);
  { draw grid and superimpose region }
  VAR	i, j: integer;
  BEGIN
    TkClearWindow(id);
    TkGpText(id, 5,15,'Solving Laplace equation on a disk with different heating');
    TkGpText(id, 5,15+TkCellHeight(id),'  (the disk is cooled on the left, heated on the right).');
    IF init THEN
      TkGpText(id, 5,15+3*TkCellHeight(id),'  Initial ...')
    ELSE
      TkGpText(id, 5,15+3*TkCellHeight(id),'  Final ...');
    TkDispatchToWindow(id);
    TkGraphColor(id, TkWhite);
    TkSetView3D(id);
    TkSetScales(id);
    TkDrawAxes(id);
    TkLabelAxes(id);
    { map out region }
    TkGraphColor(id, TkYellow);
    FOR i := 1 TO knx+1 DO FOR j := 1 TO kny+1 DO IF NOT b[i, j] THEN
      TkPlotSymbol(id, TkGetArray1(xref, i), TkGetArray1(yref, j), plus_symbol);
    TkDrawSurfaceArray(id, xref, yref, u, knx + 1, kny + 1,
    wireframe, TkLightcyan, TkLightBlue, preset);
    TkDispatchToWindow(id);
  END;

  {-- Local procedure ------------------------------------------------------}
  PROCEDURE gauss_seidal;
  { construct iterative solution }
  VAR i, j, k: integer;
      gArray: PGaussArray;
  BEGIN
    gArray := PGaussArray(TkGetArrayAddress(u));
    FOR k := 1 TO Count DO BEGIN { k is number of iterations }
      FOR i := 2 TO knx DO FOR j := 2 TO kny DO IF b[i, j] THEN
      BEGIN
        GArray^[i, j] := (GArray^[i+1, j] + GArray^[i-1, j]
          + GArray^[i, j-1] + GArray^[i, j+1]) / 4;
      END;
    END;
  END;

{-- main program for solving Laplace equation ------------------------------}
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  xref := TkNewArray1(knx + 1);
  yref := TkNewArray1(kny + 1);
  u := TkNewArray2(knx + 1, kny + 1);
  IF (u <> Nil) AND (xref <> Nil) AND (yref <> Nil) THEN BEGIN
    { Circular disk with differential heating, assume xl = -xh and yl = -yh }
    setranges;
    FOR i := 1 to knx+1 DO FOR j := 1 to kny+1 DO BEGIN
      { differential heating: left - hot, right - cold }
      TkSetArray2(u, i, j, Degree * RaisePower(ABS(TkGetArray1(xref, i)/xl),
        1/6)* Sgn(TkGetArray1(xref, i)));
      b[i, j] := (sqr(TkGetArray1(xref, i)) + sqr(TkGetArray1(yref, j))
        < Sqr(Radius));
    END;
    drawregion(true);
    Gauss_seidal; { solve }
    drawregion(false);
  END;
  TkDisposeArray(u);
  TkDisposeArray(xref);
  TkDisposeArray(yref);
  SetWaiting(false);
  LastCommand := 25;
  mouseValueMode := 2;
END; { Wire Frame }


PROCEDURE Csin(x, y: TkReal; VAR rx, ry: TkReal);
{ calculate |Sin(x + I y)|, result as rx + I ry }
BEGIN
  rx := sin(x) * (exp(y) + exp(-y)) / 2;
  ry := cos(x) * (exp(y) - exp(-y)) / 2;
END; { Csin }

FUNCTION fsur(x, y: TkReal): TkReal; FAR;
VAR rx, ry: TkReal;
BEGIN
  Csin(x, y, rx, ry);
  fsur := Sqrt(rx*rx + ry*ry)
END; { fsur }


procedure TForm1.MnuSurfaceClick(Sender: TObject);
{ Surface plot of |Sin(x + I y)| where |x| < Pi, |y| < 1. }
CONST ndata = 32;
      rlx = -Pi; rhx = Pi;
      rly = -1;  rhy = 1;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkClearWindow(id);
  TkGraphTitle(id, Graph_title,'Surface plot of |Sin(x + I y)| where |x| < Pi, |y| < 1');
  TkDispatchToWindow(id);
  TkSetRanges3(id, -Pi, Pi, -1, 1, 0, 2);
  TkSetView3D(id);
  TkSetScales(id);
  TkDrawSurface(id,
    'sqrt( (sin(x) * (exp(y) + exp(-y)) / 2)^2 + (cos(x) * (exp(y) - exp(-y)) / 2)^2)',
    'x', 'y', -Pi, Pi, -1, 1, ndata, ndata, surface,
    TkCyan, TkLightBlue, Preset);
  TkDispatchToWindow(id);
  SetWaiting(false);
  LastCommand := 26;
  mouseValueMode := 2;
END; { Surface }

procedure TForm1.MnuHistogram2DClick(Sender: TObject);
CONST RLX = 0;
      RHX = 10;
      NDATA = 21; { no. of tosses per game + 1 }
      NSample = 500; { no. of games }
VAR   u, v: PArray;
      i, j, toss: integer;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkGpText(id, 5, 15, 'Random sampling of tossing a coin: each sample consists');
  TkGpText(id, 5, 15+TkCellHeight(id), 'of n tosses and the number of heads is recorded.');
  TkGpText(id, 5, 15+2*TkCellHeight(id), 'NB. Resize the window causes new samples to be sampled!');
  TkDispatchToWindow(id);
  TkSetMargins(id, TkCellWidth(id), 4*TkCellHeight(id), TkCellWidth(id),
    2*TkCellHeight(id));
  Randomize;
  u := TkNewArray1(NDATA);
  v := TkNewArray1(NDATA);
  IF (u <> Nil) AND (v <> Nil) THEN BEGIN
    FOR i := 1 TO NDATA DO BEGIN
      TkSetArray1(u, i, i - 1); { initialize labels }
      TkSetArray1(v, i, 0); { initialize counters }
    END;
    FOR i := 1 TO NSample DO BEGIN
      toss := 0;
      FOR j := 1 TO NDATA - 1 DO toss := toss + Random(2);
      TkSetArray1(v, toss + 1, TkGetArray1(v, toss + 1) + 1.0);
    END;  { draw samples }
    TkDrawHistogram1(id, u, v, NDATA, 1.0, 0, TkWHITE, AUTOAXES);
    TkDispatchToWindow(id);
  END;
  TkDisposeArray(u);
  TkDisposeArray(v);
  SetWaiting(false);
  LastCommand := 27;
  mouseValueMode := 1;
END; { Histogram 2D }


procedure TForm1.MnuMoreFractalsClick(Sender: TObject);
{ Julia set }
CONST Ntest = 80;  { no. of points per dimension to test whether it escapes }
      Nplot = 15;  { no. of bars per dimension to plot in histogram }
      NIter = 25;
      Relo = - Pi; Rehi = Pi;
      Imlo = - 2 * Pi; Imhi = 2 * Pi;
      TooBig = 400.0;
      Sc = 7; { for display }
{-- Local procedure --------------------------------------------------------}
  PROCEDURE lamSin(VAR x, y: TkReal);
  { iterate  S(z) = lambda * sin(z), where z = x + I y }
  CONST RePart = 1;
        ImPart = 0.4;
  VAR tx, ty: TkReal;
  BEGIN
    Csin(x, y, tx, ty);
    x := tx * RePart - ty * ImPart;
    y := tx * ImPart + ty * RePart;
  END;
{-- Main body --------------------------------------------------------------}
VAR a, u, v: PArray;
    i, j, k, count: integer;
    testRe, testIm, dRe, dIm, dbRe, dbIm: TkReal; { for building data }
    keepRe, keepIm, clr: TkReal; { for 2D plot }
    wx, wy: integer;
    barRe, barIm: integer;  { for histogram }
    quited: Boolean;
BEGIN
  SetWaiting(true);
  ResetDefaults(true);
  TkGraphTitle(id, Graph_title, 'The Julia set of S(z) = lambda * sin(z), where z = x + I y.');
  TkDispatchToWindow(id);
  { make a 2D plot first }
  wx := TkWindowWidth(id) - Ntest * 3 DIV 2;
  wy := (TkWindowHeight(id) - Ntest) DIV 2;
  TkGpRectangle(id, wx, wy, wx + Ntest + 1, wy + Ntest + 1, false);
  dRe := (Rehi - Relo) / Ntest;
  dIm := (Imhi - Imlo) / Ntest;
  dbRe := (Rehi - Relo) / Nplot;
  dbIm := (Imhi - Imlo) / Nplot;
  a := TkNewArray2(Nplot, Nplot);
  u := TkNewArray1(Nplot);
  v := TkNewArray1(Nplot);
  IF (a <> Nil) AND (u <> Nil) AND(v <> Nil) THEN BEGIN
    FOR i := 1 TO Ntest DO BEGIN
      FOR j := 1 TO Ntest DO BEGIN
        testRe := (i - 0.5) * dRe + Relo;  { where the test starts }
        testIm := (j - 0.5) * dIm + Imlo;
        barRe := Trunc((testRe - Relo) / dbRe) + 1; { where the result is stored in array }
        barIm := Trunc((testIm - Imlo) / dbIm) + 1;
        k := 0;
        keepRe := testRe;
        keepIm := testIm;
        REPEAT
          lamSin(testRe, testIm);
          Inc(k);
          quited := (testRe * testRe + testIm * testIm > TooBig)
        UNTIL quited OR (k >= NIter);
        TkSetArray2(a, barRe, barIm, k);
        TkSetArray1(u, barRe, (barRe - 0.5) * dbRe + Relo);
        TkSetArray1(v, barIm, (barIm - 0.5) * dbIm + Imlo);
        clr := k / NIter;  { a color density between 0 and 1, where
          1 means 'stay' and is therefore in Julia set }
        TkGraphColor(id, TkRGB(round(sqrt(clr) * 255), round(clr * 125) + 130,
          round(clr * 255), true));
        TkGpPixel(id, wx + i, wy + (Ntest + 1 - j));
      END
    END;
    TkDispatchToWindow(id);
    { make 3D plot }
    TkSetMargins(id, 6*TkCellWidth(id), 2*TkCellHeight(id),
      15*TkCellWidth(id), 2*TkCellHeight(id));
    TkSetGraphParam(id, AxesType_gp, Boxed_axes);
    TkSetViewangles(id, Pi/7+0.5, Pi/4);
    TkDrawHistogram2(id, u, v, a, Nplot, Nplot, 0.5, 0.5, TkLIGHTMAGENTA,
      AutoAxes);
    TkDispatchToWindow(id);
    TkDisposeArray(a);
    TkDisposeArray(u);
    TkDisposeArray(v);
  END;
  SetWaiting(false);
  LastCommand := 28;
  mouseValueMode := 2;
END; { More fractals / Histogram3D }


procedure TForm1.DrawUserdefinedFunction;
var result: integer;
begin
  ResetDefaults(true);
  TkSetMargins(id, 5 * TkCellWidth(id), 3 * TkCellHeight(id), 1 *
    TkCellWidth(id), 5 * TkCellWidth(id));
  TkDispatchToWindow(id);
  result := TkDrawCurve1(id, editText, 'x', 0, 10, 128, TkBlue, Autoaxes);
  TkGraphTitle(id, Graph_title, EditText);
  IF (result >= 10400) AND (result <= 10413) THEN
    TkGpText(id, 2, 2+TkCellHeight(id), 'Cannot compile - syntax error!');
  IF (result >= 10414) AND (result <= 10499) THEN
    TkGpText(id, 2, 2+TkCellHeight(id), 'Cannot evaluate - singularity!');
  TkDispatchToWindow(id);
end;


procedure TForm1.MnuUserdefinedFunctionClick(Sender: TObject);
VAR Ansi_s: AnsiString;
BEGIN
  Ansi_s := editText;
  IF InputQuery('User defined function',
    'Enter f(x) and see a plot of x in [0, 10]:', Ansi_s) THEN
  BEGIN
    StrPLCopy(editText, Ansi_s, 500 - 1);
    DrawUserdefinedFunction;
  END;
  LastCommand := 29;
  mouseValueMode := 1;
END;

procedure TForm1.MnuLoglogplotClick(Sender: TObject);
VAR i: integer;
BEGIN
  ResetDefaults(true);
  TkSetGraphParam(id, ScaleType_gp, LogLog_scales);
  TkSetGraphParam(id, AxesType_gp, Boxed_axes);
  TkSetGraphParam(id, AutoMargins_gp, 1);
  TkSetGraphParam(id, GridOption_gp, 1);
  // TkSetGraphParam(id, AutoNiceValues_gp, 0);
  TkSetRanges(id, 10, 100, 100, 10000);
  TkSetScales(id);
  TkDrawAxes(id);
  TkLabelAxes(id);
  TkDispatchToWindow(id);
  // try to plot some points on the curve y = x^2
  FOR i := 1 TO 8 DO TkPlotSymbol(id, i*10, sqr(i*10), i);
  // now draw a line overlapping the points
  TkMoveAbs(id, 10, 100);
  FOR i := 2 TO 8 DO TkDrawAbs(id, i*10, sqr(i*10));
  SetWaiting(false);
  LastCommand := 30;
  mouseValueMode := 1;
END; {Loglogplot}

procedure TForm1.MnuAboutClick(Sender: TObject);
var s: string;
const CRLF = chr(13) + chr(10);
begin
  s := 'SToMP graphics DLL TKGRPW32.DLL' + CRLF;
  s := s + 'DLL version number: '+inttostr(TkGetVersion) + CRLF + CRLF;
  s := s + 'Atta Chui 1994-2000 (C)' + CRLF + CRLF + CRLF;
  s := s + 'Based on the package "Scientific Programmer''s Toolkit" by' + CRLF;
  s := s + 'M.H. Beilby, R.D. Harding and M.R. Manning (1991).';
  ShowMessage(s);
end;

procedure TForm1.ClearWindow1Click(Sender: TObject);
begin
  ResetDefaults(true);
end;

end.
